title 'Airline';
proc sgplot data=sashelp.air;
	series x=date y=air;
run;

data air_for_reg;
	set sashelp.air;
	logair = log(air);
	t = _n_; * time trend;
	* seasonal dummies;
	d1 = (month(date) = 1);
	d2 = (month(date) = 2);
	d3 = (month(date) = 3);
	d4 = (month(date) = 4);
	d5 = (month(date) = 5);
	d6 = (month(date) = 6);
	d7 = (month(date) = 7);
	d8 = (month(date) = 8);
	d9 = (month(date) = 9);
	d10 = (month(date) = 10);
	d11 = (month(date) = 11);
	d12 = (month(date) = 12);
	* seasonal sinusoids;
	bf = 2*constant('pi')/12;
	c1 = cos(1*bf*t);
	c2 = cos(2*bf*t);
	c3 = cos(3*bf*t);
	c4 = cos(4*bf*t);
	c5 = cos(5*bf*t);
	c6 = cos(6*bf*t);
	s1 = sin(1*bf*t);
	s2 = sin(2*bf*t);
	s3 = sin(3*bf*t);
	s4 = sin(4*bf*t);
	s5 = sin(5*bf*t);
	drop bf;
run;

title 'Log of Airline';
proc sgplot data=air_for_reg;
	series x=date y=logair;
run;

* RUN THE REGRESSION ON TREND AND SEASONAL;
proc reg data=Air_for_reg;
	id date;
	eq1: model logair = t d1-d12;
	output out=reg_logair1 p=yhat r=yresid;
	eq2: model logair = t c1-c6 s1-s5;
	output out=reg_logair2 p=yhat r=yresid;
run;
quit;

* LET US MAKE THE LINEAR TREND;
data reg_logair;
	set reg_logair2;
	trend = 4.81219 + t*0.01007;
run;

* PLOT TREND AND TIME SERIES;
proc sgplot data=reg_logair;
	scatter x=date y=logair;
	series x=date y=yhat;
	series x=date y=trend / lineattrs=(color = red);
run;
